(*
 * sudoku.ml
 *
 *     Imperative sudoku solver in ocaml.
 * 
 *)

open Printf

(* The size of each side of the board. *)
let side_size = 9

(* The size of each side of a small box. *)
let box_size = 3

(* The type of boards. *)
type board = int array array

(* Exception type for board solver. *)
exception Found of board


(*
 * Board representation:
 * -- a board is a 9x9 two-dimensional array of ints
 * -- each square contains an int between 0 and 9
 * -- 0 means that the board's real value is unknown.
 * 
 *)


(** Read in a sudoku board from a file.  Return the board. *)
let read_board filename =
   failwith "not implemented yet"


(** Print a sudoku board.  Return nothing. *)
let print_board chan board =
   failwith "not implemented yet"


(** Solve a sudoku board. 
    Return an option type giving the solution (a board)
    or None if no solution exists. *)
let solve_board board = 
   failwith "not implemented yet"


(** Solve a sudoku board taken from a file, and print the result. *)
let solve_board_from_file filename =
   let b = read_board filename in
      match solve_board b with
         | None   -> printf "Board has no solution.\n"
         | Some b -> print_board stdout b


(** Entry point. *)
let _ = 
   if Array.length Sys.argv <> 2 then
      begin
         fprintf stderr "usage: %s board\n" Sys.argv.(0);
         exit 1
      end
   else
      begin
         solve_board_from_file Sys.argv.(1);
         exit 0
      end


